/*
===========================================================================

Doom 3 BFG Edition GPL Source Code
Copyright (C) 1993-2012 id Software LLC, a ZeniMax Media company.

This file is part of the Doom 3 BFG Edition GPL Source Code ("Doom 3 BFG Edition Source Code").

Doom 3 BFG Edition Source Code is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Doom 3 BFG Edition Source Code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Doom 3 BFG Edition Source Code.  If not, see <http://www.gnu.org/licenses/>.

In addition, the Doom 3 BFG Edition Source Code is also subject to certain additional terms. You should have received a copy of these additional terms immediately following the terms and conditions of the GNU General Public License which accompanied the Doom 3 BFG Edition Source Code.  If not, please request a copy in writing from id Software at the address below.

If you have questions concerning this license or the applicable additional terms, you may contact in writing id Software LLC, c/o ZeniMax Media Inc., Suite 120, Rockville, Maryland 20850 USA.

===========================================================================
*/

#ifndef __G_GAME__
#define __G_GAME__

#include "doomdef.h"
#include "d_event.h"



//
// GAME
//
void G_DeathMatchSpawnPlayer( int playernum );

void G_InitNew( skill_t skill, int episode, int map );

// Can be called by the startup code or M_Responder.
// A normal game starts at map 1,
// but a warp test can start elsewhere
void G_DeferedInitNew( skill_t skill, int episode, int map );

void G_DeferedPlayDemo( const char* demo );

// Can be called by the startup code or M_Responder,
// calls P_SetupLevel or W_EnterWorld.
void G_LoadGame( char* name );

qboolean G_DoLoadGame();

// Called by M_Responder.
void G_SaveGame( int slot, char* description );

// Only called by startup code.
void G_RecordDemo( char* name );

void G_BeginRecording( void );

void G_PlayDemo( char* name );
void G_TimeDemo( const char* name );
qboolean G_CheckDemoStatus( void );

void G_ExitLevel( void );
void G_SecretExitLevel( void );

void G_WorldDone( void );

void G_Ticker( void );
qboolean G_Responder( event_t*	ev );

void G_ScreenShot( void );

#define MAXDEMOSIZE		512 * 1024
#define SAVEGAMESIZE	256 * 1024 + MAXDEMOSIZE


#endif

