/*
===========================================================================

Doom 3 BFG Edition GPL Source Code
Copyright (C) 1993-2012 id Software LLC, a ZeniMax Media company.

This file is part of the Doom 3 BFG Edition GPL Source Code ("Doom 3 BFG Edition Source Code").

Doom 3 BFG Edition Source Code is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Doom 3 BFG Edition Source Code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Doom 3 BFG Edition Source Code.  If not, see <http://www.gnu.org/licenses/>.

In addition, the Doom 3 BFG Edition Source Code is also subject to certain additional terms. You should have received a copy of these additional terms immediately following the terms and conditions of the GNU General Public License which accompanied the Doom 3 BFG Edition Source Code.  If not, please request a copy in writing from id Software at the address below.

If you have questions concerning this license or the applicable additional terms, you may contact in writing id Software LLC, c/o ZeniMax Media Inc., Suite 120, Rockville, Maryland 20850 USA.

===========================================================================
*/

#include "Precompiled.h"

#ifdef __GNUG__
	#pragma implementation "m_fixed.h"
#endif
#include "m_fixed.h"

#include "globaldata.h"

#include "stdlib.h"

#include "doomtype.h"
#include "i_system.h"


// Fixme. __USE_C_FIXED__ or something.

fixed_t
FixedMul
( fixed_t	a,
  fixed_t	b )
{
	return fixed_t( ( ( long long ) a * ( long long ) b ) >> FRACBITS );
}



//
// FixedDiv, C version.
//

fixed_t
FixedDiv
( fixed_t	a,
  fixed_t	b )
{
	if( ( abs( a ) >> 14 ) >= abs( b ) )
	{
		return ( a ^ b ) < 0 ? MININT : MAXINT;
	}
	return FixedDiv2( a, b );
}



fixed_t
FixedDiv2
( fixed_t	a,
  fixed_t	b )
{
#if 0
	long long c;
	c = ( ( long long )a << 16 ) / ( ( long long )b );
	return ( fixed_t ) c;
#endif

	double c;

	c = ( ( double )a ) / ( ( double )b ) * FRACUNIT;

	if( c >= 2147483648.0 || c < -2147483648.0 )
	{
		I_Error( "FixedDiv: divide by zero" );
	}
	return ( fixed_t ) c;
}

